#!/usr/bin/perl

#
# httpdmem.pl for Windows 2000 !! (w2k patch by Ralf Hach)
#
# Interface for Apache and MRTG
#
# Copyright 2008 by Steffen Land, info@apachelounge.com .  All rights reserved.
#



$CACHE_FILE = "memsnap.log";

sub RetrieveStats(){
  $null = @ENV{COMPUTERNAME} ? "nul" : "/dev/null" ;
  `del memsnap.log`;
  `memsnap.exe 2>$null`;

}
sub Validate() {
  if ((scalar(@ARGV) < 2) || ($ARGV[0] eq '')) {
     print "ERR: invalid arguments.\n";
     exit;
  }
}
Validate();
@type = ($ARGV[0],$ARGV[1]);
while (@ARGV) { $x=shift(@ARGV); if ($x =~ /-conf/) {require shift(@ARGV);}}
@result = (0,0);
$complete = 0;
if ( time() - (stat($CACHE_FILE))[9] > (60*2) ){	
	RetrieveStats();
}

open(IN,"< $CACHE_FILE") or die "Could not open cached file";
foreach $line ( <IN> ){

	for($i=0;$i<=1;$i++){
if ($type[$i] eq "httpdmem" && $line =~ /httpd.exe\D*(\d+)/) {$result[$i]=($result[$i]+$1);next;}
if ($type[$i] eq "systemmem" && $line =~ /$\.{28}(\d+)/) {$result[$i]=($result[$i]+$1);next;}
if ($type[$i] eq "null") {$result[$i]="0";}

	}
}
close IN;
print $result[0]."\n";
print $result[1]."\n";
print $uptime."\n";
print $host."\n";

